var editSenderObj  = {
	
	init : function() {
		editSenderObj.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		editSenderObj.setLabel();
		editSenderObj.setPopupHiding();
		if (! document.getElementById("editSenderBox").collapsed)
			editSenderObj.hideBox();
	},

	hideBox : function() {
		if (document.getElementById("editSenderBox"))
			document.getElementById("editSenderBox").collapsed = true;
	},

	setLabel : function() {
		var recycle = editSenderObj.prefs.getBoolPref("extension.editsender.load_last_used_values");
		try {
			var curr = getCurrentIdentity();
			if (curr.attachVCard) {
				document.getElementById("vcardCheckBox").removeAttribute("hidden");
				document.getElementById("vcardCheckBox").checked = true;
			}
			else {
				document.getElementById("vcardCheckBox").checked = false;
				document.getElementById("vcardCheckBox").setAttribute("hidden", "true");
			}
				
			if (recycle) {
				document.getElementById("editSenderName").value = editSenderObj.prefs.getCharPref("extension.editsender."+curr.key+".last_temp_name");
				document.getElementById("editSenderAddress").value = editSenderObj.prefs.getCharPref("extension.editsender."+curr.key+".last_temp_mail");
				document.getElementById("editSenderOrg").value = editSenderObj.prefs.getCharPref("extension.editsender."+curr.key+".last_temp_org");
			}	
			else {
				document.getElementById("editSenderName").value = curr.fullName;
				document.getElementById("editSenderAddress").value = curr.email;
				document.getElementById("editSenderOrg").value = curr.organization;
			}
		}
		catch(e) {
			document.getElementById("editSenderName").value = "";
			document.getElementById("editSenderAddress").value = "";
			document.getElementById("editSenderOrg").value = "";
		}
	},
	
	setPopupHiding : function() {
		var msgpop = document.getElementById("msgIdentityPopup");
		if (msgpop)
			msgpop.setAttribute("onpopuphiding", "editSenderObj.setLabel()");
	},
	
	toggle : function() {
		document.getElementById("editSenderBox").collapsed = false;
		document.getElementById("editSenderName").focus();
		document.getElementById("editSenderName").select();
	},
	
	setTempValues : function() {
		var id = getCurrentIdentity();
		var realName = id.fullName;
		var realVcard = id.escapedVCard;
		var realEmail = id.email;
		var realOrg = id.organization;
		id.fullName = document.getElementById("editSenderName").value;
		if (! document.getElementById("vcardCheckBox").checked) 		
			id.escapedVCard= "";
		id.email = document.getElementById("editSenderAddress").value;
		id.fullName = document.getElementById("editSenderName").value;
		id.organization = document.getElementById("editSenderOrg").value;
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		editSenderObj.prefs.setCharPref("extension.editsender."+id.key+".last_temp_mail", id.email);
		editSenderObj.prefs.setCharPref("extension.editsender."+id.key+".last_temp_name", id.fullName);
		editSenderObj.prefs.setCharPref("extension.editsender."+id.key+".last_temp_org", id.organization);
		setTimeout(function() {
			id.email = realEmail;
			id.fullName = realName;
			id.organization = realOrg;
			id.escapedVCard = realVcard;
		}, 1000);
	}
};


var SendMessage8848 = SendMessage;
SendMessage = function() {
	if ( ! document.getElementById("editSenderBox").collapsed) 
		editSenderObj.setTempValues();
	SendMessage8848.apply(this,arguments);
};

var SendMessageWithCheck8848 = SendMessageWithCheck;
SendMessageWithCheck = function () {
	if ( ! document.getElementById("editSenderBox").collapsed) 
		editSenderObj.setTempValues();
	SendMessageWithCheck8848.apply(this,arguments);
};

var SendMessageLater8848 = SendMessageLater;
SendMessageLater = function () {
	if ( ! document.getElementById("editSenderBox").collapsed) 
		editSenderObj.setTempValues();
	SendMessageLater8848.apply(this,arguments);
};


window.addEventListener("compose-window-close", editSenderObj.hideBox, true);
window.addEventListener("compose-window-reopen", editSenderObj.init, true)
window.addEventListener("load", editSenderObj.init, true);
